/******************* (C) COPYRIGHT 2009~2021 holychip **************************
* File Name          : LED.c
********************************************************************************


*******************************************************************************/
#include "HC89F3541.h"
#include "KEY.h"
#include "LED.h"
#include "BUZZ.h"
#include "EEPROM.h"
#include "HC89F3xx1_SYS.h"
#include "HolyChip_Level_Touch_Lib_V1.00\HolyChip_Level_Touch_Lib.h"
//===============================================================================

bit TEST_OK = 0;//У׼ɱ־λ
bit Wait_Flag = 0;
bit MODE_A = 1;//
bit MODE_B = 1;
bit LED_TIG_INIT_EN_F = 0;
bit BUZZ_FLAG = 0;
unsigned char xdata LED_SCINTILLATION_Cnt = 0;

void LED_TIG_INIT(void)
{
	if(LED_TIG_INIT_EN_F)
	{
		LED_TIG_INIT_EN_F = 0;
		PWM3P = SYSCLK_FOSC / 64 / 1000;  		//SYSCLK_FOSC/64/PWM3P = xx  HZ
		BZ_KEY_TIG1;
	}
}

void KEY_LED_PROCESS()
{
	if(Calibration_Level_Flag)	
	{
		BUZZ_FLAG = 1;
		if(Level_F==0)
		{
			Wait_Flag = 1;
			LED_SCINTILLATION_Cnt++;
			if(LED_SCINTILLATION_Cnt>=50)
			{
				LED_SCINTILLATION_Cnt = 0;
				LED_TURN;//еƷת
				LED_TIG_INIT_EN_F = 1;
			}
	    }
		else if(Level_F==1)//ˮУ׼ʾ
		{
			Wait_Flag = 0;
			LED_SCINTILLATION_Cnt++;
			if(LED_SCINTILLATION_Cnt>=50)
			{
				LED_SCINTILLATION_Cnt = 0;
				LED8 = ~LED8;
				LED_TIG_INIT_EN_F = 1;
			}
			
		}
		else if(Level_F==2)
		{
			if(MODE_A)
			{
		     LEVEL_CALIBRATION(0);//ˮУ׼ʱһ
			  EA = 0;
			  SAVE_DATA(0X3C00,6,Empty_Value);
			  EA = 1;
			  MODE_A = 0;
			}
		    LED8 = 1;
		}
		else if(Level_F==3)
		{
			LED_SCINTILLATION_Cnt++;
			if(LED_SCINTILLATION_Cnt>=50)
			{
				LED_SCINTILLATION_Cnt = 0;
				LED7 = ~LED7;
				LED_TIG_INIT_EN_F = 1;
			}
		}
		else if(Level_F==4)
		{
			if(MODE_B)
			{
			  LEVEL_CALIBRATION(1);//ˮУ׼ʱһ
			  TEST_OK = 1;       //ˮˮУ׼ʱñ־λ
			  EA = 0;
			  SAVE_DATA(0X3D00,6,Full_Value);
			  SAVE_FLAG(0X3E00,TEST_OK);
			  EA = 1;
			  MODE_B = 0;	
							
			}
		    LED7 = 1;
	
		}
		else if(Level_F==5)
		{
			
			Calibration_Level_Flag = 0;
		}
		
	}
	else
	{
		Level_F = 0;
		MODE_A = 1;
		MODE_B = 1;
		
		if(BUZZ_FLAG)
		{
		  BUZZ_FLAG = 0;
		  BZ_KEY_TIG2;
		}
	}

}

void Display_Process()
{
  	if(Level_Key_Flag & TK4)
	{
		
		LED1 = 1;
	}
	else
	{
		LED1 = 0;
	}
	
	if(Level_Key_Flag & TK6)
	{
		LED2 = 1;
	}
	else
	{
		LED2 = 0;
	}
	
	if(Level_Key_Flag & TK8)
	{
		LED3 = 1;
	}
	else
	{
		LED3 = 0;
	}
		if(Level_Key_Flag & TK10)
	{
		LED4 = 1;
	}
	else
	{
		LED4 = 0;
	}
		if(Level_Key_Flag & TK13)
	{
		LED5 = 1;
	}
	else
	{
		LED5 = 0;
	}
		if(Level_Key_Flag & TK15)
	{
		LED6 = 1;
	}
	else
	{
		LED6 = 0;
	}
}